import java.util.Vector;


public class TestCase_D_ILLEGAL_DN_VAL extends TestCase_D {

	
	final private String TEST_CASE_ID = Globals.TC_D_ILLEGAL_DN_VAL;
	String getTestCaseId () {return this.TEST_CASE_ID;}
	
	final private int PRIORITY = 100;
	int getPriority () {return this.PRIORITY;}
	
	final private MyHashMap PROPS = new MyHashMap () {{
	}};
	MyHashMap getProps () {return this.PROPS;}
	
	
	public TestCase_D_ILLEGAL_DN_VAL (MyAttribute att, Entry ent, EntrySet modified) {
		super(att,ent,modified);
	}
	
	
	void calculateVals () {
		this.entryToDelete = this.createIllegalDnValEntry();
	}
	
	void calculateExpected () {}
	
	
	private Entry createIllegalDnValEntry () {
		
		Entry entry = (Entry)this.ent.clone();
		if (entry==null) entry = new Entry("",new Vector());
		boolean someModif = false;
		boolean modifAll = Globals.randGen.nextInt(100)<25;
		
		for (int i=0; i<entry.getNumbOfAttrs(); i++) {
			
			MyAttribute att = entry.getAttributeAt(i);
			String attName = att.getName();
			try {if (Globals.hasPropertyByRdnId(entry.getRdnId(),attName,Globals.PROP_LINKED)==false) continue;}
			catch (Exception exc) {
				if (Certification.DEBUGGING_INFO) Loggin.Log(Globals.indent()+"Exception: \""+exc.getMessage()+"\" in TestCase_D_ILLEGAL_DN_VAL.createIllegalDnValEntry");
			}
			if (!modifAll && someModif && Globals.randGen.nextInt(100)<50) continue;
			String attVal = att.getValueAt(0);
			String val = null;
			int tries = 0;
			do {
				val = Globals.getIllegalValue(entry.getRdnId(),attName);
				if (val==null) continue;
			} while(++tries<this.MAX_NUMB_OF_TRIES_FOR_ADDING_NEW_ENTRY && (val==null || attVal.equalsIgnoreCase(val)));
			if (tries==this.MAX_NUMB_OF_TRIES_FOR_ADDING_NEW_ENTRY) continue;
			att.removeAllValues(false);
			Vector vals = new Vector();
			vals.add(val);
			att.addValue(vals);
			someModif = true;
		}
		if (someModif==false) return null;
		
		if (entry.adjustDnToLinked()==false) this.skipTest = true;
		
		return entry;
	}
}
